"use strict";

var _classProps = function (child, staticProps, instanceProps) {
  if (staticProps) Object.defineProperties(child, staticProps);
  if (instanceProps) Object.defineProperties(child.prototype, instanceProps);
};

var MapGenerator = require("./map-generator");

var Result = (function () {
  var Result = function Result(root, opts) {
    if (opts === undefined) opts = {};
    this.root = root;
    this.opts = opts;
  };

  _classProps(Result, null, {
    map: {
      get: function () {
        if (!this.cssCached) this.stringify();
        return this.mapCached;
      }
    },
    css: {
      get: function () {
        if (!this.cssCached) this.stringify();
        return this.cssCached;
      }
    },
    toString: {
      writable: true,
      value: function () {
        return this.css;
      }
    },
    stringify: {
      writable: true,
      value: function () {
        var map = new MapGenerator(this.root, this.opts);
        var generated = map.generate();
        this.cssCached = generated[0];
        this.mapCached = generated[1];
      }
    }
  });

  return Result;
})();

module.exports = Result;